#include "notifier.h"
#include <SDL3/SDL_blendmode.h> // Para SDL_BLENDMODE_BLEND
#include <SDL3/SDL_pixels.h>    // Para SDL_PIXELFORMAT_RGBA8888
#include <string>               // Para string
#include <algorithm>
#include <vector>
#include "audio.h"   // Para JA_DeleteSound, JA_LoadSound, JA_Pla...
#include "param.h"   // Para Param, param, ParamNotification, Par...
#include "screen.h"  // Para Screen
#include "sprite.h"  // Para Sprite
#include "text.h"    // Para Text
#include "texture.h" // Para Texture
#include "resource.h"

// [SINGLETON]
Notifier *Notifier::notifier_ = nullptr;

// [SINGLETON] Crearemos el objeto con esta función estática
void Notifier::init(const std::string &icon_file, std::shared_ptr<Text> text)
{
    Notifier::notifier_ = new Notifier(icon_file, text);
}

// [SINGLETON] Destruiremos el objeto con esta función estática
void Notifier::destroy()
{
    delete Notifier::notifier_;
}

// [SINGLETON] Con este método obtenemos el objeto y podemos trabajar con él
Notifier *Notifier::get()
{
    return Notifier::notifier_;
}

// Constructor
Notifier::Notifier(std::string icon_file, std::shared_ptr<Text> text)
    : renderer_(Screen::get()->getRenderer()),
      icon_texture_(!icon_file.empty() ? std::make_unique<Texture>(renderer_, icon_file) : nullptr),
      text_(text),
      bg_color_(param.notification.color),
      wait_time_(150),
      stack_(false),
      has_icons_(!icon_file.empty()) {}

// Dibuja las notificaciones por pantalla
void Notifier::render()
{
    for (int i = (int)notifications_.size() - 1; i >= 0; --i)
    {
        notifications_[i].sprite->render();
    }
}

// Actualiza el estado de las notificaiones
void Notifier::update()
{
    for (int i = 0; i < (int)notifications_.size(); ++i)
    {
        // Si la notificación anterior está "saliendo", no hagas nada
        if (i > 0)
        {
            if (notifications_[i - 1].state == NotificationStatus::RISING)
            {
                break;
            }
        }

        notifications_[i].counter++;

        // Hace sonar la notificación en el primer frame
        if (notifications_[i].counter == 1)
        {
            if (param.notification.sound)
            {
                if (notifications_[i].state == NotificationStatus::RISING)
                {
                    // Reproduce el sonido de la notificación
                    Audio::get().playSound("notify.wav");
                }
            }
        }

        // Comprueba los estados
        if (notifications_[i].state == NotificationStatus::RISING)
        {
            const float step = ((float)notifications_[i].counter / notifications_[i].travel_dist);
            const int alpha = 255 * step;

            if (param.notification.pos_v == NotifyPosition::TOP)
            {
                notifications_[i].rect.y++;
            }
            else
            {
                notifications_[i].rect.y--;
            }
            notifications_[i].texture->setAlpha(alpha);

            if (notifications_[i].rect.y == notifications_[i].y)
            {
                notifications_[i].state = NotificationStatus::STAY;
                notifications_[i].texture->setAlpha(255);
                notifications_[i].counter = 0;
            }
        }

        else if (notifications_[i].state == NotificationStatus::STAY)
        {
            if (notifications_[i].counter == wait_time_)
            {
                notifications_[i].state = NotificationStatus::VANISHING;
                notifications_[i].counter = 0;
            }
        }
        else if (notifications_[i].state == NotificationStatus::VANISHING)
        {

            const float step = (notifications_[i].counter / (float)notifications_[i].travel_dist);
            const int alpha = 255 * (1 - step);

            if (param.notification.pos_v == NotifyPosition::TOP)
            {
                notifications_[i].rect.y--;
            }
            else
            {
                notifications_[i].rect.y++;
            }
            notifications_[i].texture->setAlpha(alpha);

            if (notifications_[i].rect.y == notifications_[i].y - notifications_[i].travel_dist)
            {
                notifications_[i].state = NotificationStatus::FINISHED;
            }
        }

        notifications_[i].sprite->setPosition(notifications_[i].rect);
    }

    clearFinishedNotifications();
}

// Elimina las notificaciones finalizadas
void Notifier::clearFinishedNotifications()
{
    for (int i = (int)notifications_.size() - 1; i >= 0; --i)
    {
        if (notifications_[i].state == NotificationStatus::FINISHED)
        {
            notifications_.erase(notifications_.begin() + i);
        }
    }
}

void Notifier::show(std::vector<std::string> texts, int icon, const std::string &code)
{
    // Si no hay texto, acaba
    if (texts.empty())
    {
        return;
    }

    // Si las notificaciones no se apilan, elimina las anteriores
    if (!stack_)
    {
        clearAllNotifications();
    }

    // Elimina las cadenas vacías
    texts.erase(std::remove_if(texts.begin(), texts.end(), [](const std::string &s)
                               { return s.empty(); }),
                texts.end());

    // Encuentra la cadena más larga
    std::string longest;
    for (const auto &text : texts)
    {
        if (text.length() > longest.length())
            longest = text;
    }

    // Inicializa variables
    constexpr int ICON_SIZE = 16;
    constexpr int PADDING_OUT = 1;
    const float PADDING_IN_H = text_->getCharacterSize();
    const float PADDING_IN_V = text_->getCharacterSize() / 2;
    const int ICON_SPACE = icon >= 0 ? ICON_SIZE + PADDING_IN_H : 0;
    const float WIDTH = text_->lenght(longest) + (PADDING_IN_H * 2) + ICON_SPACE;
    const float HEIGHT = (text_->getCharacterSize() * texts.size()) + (PADDING_IN_V * 2);
    const auto SHAPE = NotificationShape::SQUARED;

    // Posición horizontal
    float desp_h = 0;
    switch (param.notification.pos_h)
    {
    case NotifyPosition::LEFT:
        desp_h = PADDING_OUT;
        break;

    case NotifyPosition::MIDDLE:
        desp_h = ((param.game.width / 2) - (WIDTH / 2));
        break;

    case NotifyPosition::RIGHT:
        desp_h = param.game.width - WIDTH - PADDING_OUT;
        break;

    default:
        desp_h = 0;
        break;
    }

    // Posición vertical
    const int DESP_V = (param.notification.pos_v == NotifyPosition::TOP) ? PADDING_OUT : (param.game.height - HEIGHT - PADDING_OUT);

    // Offset
    const auto TRAVEL_DIST = HEIGHT + PADDING_OUT;
    auto OFFSET = notifications_.empty()
                      ? DESP_V
                      : notifications_.back().y + (param.notification.pos_v == NotifyPosition::TOP ? TRAVEL_DIST : -TRAVEL_DIST);

    // Crea la notificacion
    Notification n;

    // Inicializa variables
    n.code = code;
    n.y = OFFSET;
    n.travel_dist = TRAVEL_DIST;
    n.texts = texts;
    n.shape = SHAPE;
    const float POS_Y = OFFSET + (param.notification.pos_v == NotifyPosition::TOP ? -TRAVEL_DIST : TRAVEL_DIST);
    n.rect = {desp_h, POS_Y, WIDTH, HEIGHT};

    // Crea la textura
    n.texture = std::make_shared<Texture>(renderer_);
    n.texture->createBlank(WIDTH, HEIGHT, SDL_PIXELFORMAT_RGBA8888, SDL_TEXTUREACCESS_TARGET);
    n.texture->setBlendMode(SDL_BLENDMODE_BLEND);

    // Prepara para dibujar en la textura
    n.texture->setAsRenderTarget(renderer_);

    // Dibuja el fondo de la notificación
    SDL_SetRenderDrawColor(renderer_, bg_color_.r, bg_color_.g, bg_color_.b, 255);
    SDL_FRect rect;
    if (SHAPE == NotificationShape::ROUNDED)
    {
        rect = {4, 0, WIDTH - (4 * 2), HEIGHT};
        SDL_RenderFillRect(renderer_, &rect);

        rect = {4 / 2, 1, WIDTH - 4, HEIGHT - 2};
        SDL_RenderFillRect(renderer_, &rect);

        rect = {1, 4 / 2, WIDTH - 2, HEIGHT - 4};
        SDL_RenderFillRect(renderer_, &rect);

        rect = {0, 4, WIDTH, HEIGHT - (4 * 2)};
        SDL_RenderFillRect(renderer_, &rect);
    }

    else if (SHAPE == NotificationShape::SQUARED)
    {
        SDL_RenderClear(renderer_);
    }

    // Dibuja el icono de la notificación
    if (has_icons_ && icon >= 0 && texts.size() >= 2)
    {
        auto sp = std::make_unique<Sprite>(icon_texture_, (SDL_FRect){0, 0, ICON_SIZE, ICON_SIZE});
        sp->setPosition({PADDING_IN_H, PADDING_IN_V, ICON_SIZE, ICON_SIZE});
        sp->setSpriteClip(SDL_FRect{
            static_cast<float>(ICON_SIZE * (icon % 10)),
            static_cast<float>(ICON_SIZE * (icon / 10)),
            ICON_SIZE,
            ICON_SIZE});
        sp->render();
    }

    // Escribe el texto de la notificación
    const Color color{255, 255, 255};
    int iterator = 0;
    for (const auto &text : texts)
    {
        text_->writeColored(PADDING_IN_H + ICON_SPACE, PADDING_IN_V + iterator * (text_->getCharacterSize() + 1), text, color);
        ++iterator;
    }

    // Deja de dibujar en la textura
    SDL_SetRenderTarget(renderer_, nullptr);

    // Crea el sprite de la notificación
    n.sprite = std::make_shared<Sprite>(n.texture, n.rect);

    // Deja la notificación invisible
    n.texture->setAlpha(0);

    // Añade la notificación a la lista
    notifications_.emplace_back(n);
}

// Finaliza y elimnina todas las notificaciones activas
void Notifier::clearAllNotifications()
{
    for (auto &notification : notifications_)
    {
        notification.state = NotificationStatus::FINISHED;
    }

    clearFinishedNotifications();
}

// Obtiene los códigos de las notificaciones
std::vector<std::string> Notifier::getCodes()
{
    std::vector<std::string> codes;
    for (const auto &notification : notifications_)
    {
        codes.emplace_back(notification.code);
    }
    return codes;
}